Unit AFG6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFG6R(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var A :Array of Real; var INT :Array of Integer);

implementation

procedure AFG6R(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var A :Array of Real; var INT :Array of Integer);
var
I,J,KP1,LA,M,MM1,MP1 :Integer;
X,Y :Real;
const
SYS056 :Real = 1.175495E-38;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110;
begin
{      SYS056 = SYS055 }
LA := IGH - 1;
KP1 := LOW + 1;
if ( LA <  KP1 ) 
 then goto _110;
for M:=KP1 to LA do
 begin
  MM1 := M - 1;
  X := 0.0;
  I := M;
  for J:=M to IGH do
   begin
    if ( Abs(A[(J-1)+(MM1-1)*NM]) <=  Abs(X) ) 
     then goto _10;
    X := A[(J-1)+(MM1-1)*NM];
    I := J;
_10:
   end;
  INT[M-1] := I;
  if ( I =  M ) 
   then goto _40;
{  EPECTAHOBKA CTPOK  CTOOB MATP A }
  for J:=MM1 to N do
   begin
    Y := A[(I-1)+(J-1)*NM];
    A[(I-1)+(J-1)*NM] := A[(M-1)+(J-1)*NM];
    A[(M-1)+(J-1)*NM] := Y;
_20:
   end;
  for J:=1 to IGH do
   begin
    Y := A[(J-1)+(I-1)*NM];
    A[(J-1)+(I-1)*NM] := A[(J-1)+(M-1)*NM];
    A[(J-1)+(M-1)*NM] := Y;
_30:
   end;
{  KOHE EPECTAHOBOK }
_40:
  if ( X >  SYS056 ) 
   then goto _60;
  for I:=M to IGH do
   begin
    A[(I-1)+(MM1-1)*NM] := 0.0;
_50:
   end;
  goto _100;
_60:
  MP1 := M + 1;
  for I:=MP1 to IGH do
   begin
    Y := A[(I-1)+(MM1-1)*NM];
    if ( Y =  0.0 ) 
     then goto _90;
    Y := Y/X;
    A[(I-1)+(MM1-1)*NM] := Y;
    for J:=M to N do
     begin
      A[(I-1)+(J-1)*NM] := A[(I-1)+(J-1)*NM] - Y*A[(M-1)+(J-1)*NM];
_70:
     end;
    for J:=1 to IGH do
     begin
      A[(J-1)+(M-1)*NM] := A[(J-1)+(M-1)*NM] + Y*A[(J-1)+(I-1)*NM];
_80:
     end;
_90:
   end;
_100:
 end;
_110:
end;

end.
